%define Werror_cflags %nil
%define _disable_ld_no_undefined 1

#(ie. use with rpm --rebuild):
#
#	--with debug	Compile with debugging code
# 
#  enable build with debugging code: will _not_ strip away any debugging code,
#  will _add_ -g3 to CFLAGS, will _add_ --enable-maintainer-mode to 
#  configure.

%define build_debug 0
%define build_test 0

# commandline overrides:
# rpm -ba|--rebuild --with 'xxx'
%{?_with_debug: %{expand: %%define build_debug 1}}
%{?_with_test: %{expand: %%define build_test 1}}
%{?_without_test: %global build_test 0}

%if %{build_debug}
# disable build root strip policy
%define __spec_install_post %{_libdir}/rpm/brp-compress || :

# This gives extra debuggin and huge binaries
%{expand:%%define optflags %{optflags} %([ ! $DEBUG ] && echo '-g3')}
%endif

%if %{build_debug}
%define build_debug 1
%endif

%if %{build_test}
%define build_test 1
%endif

%define _requires_exceptions perl(this)

%define major 16
%define libname %mklibname mysql %{major}
%define develname %mklibname -d mysql
%define staticdevelname %mklibname -d -s mysql

%define muser	mysql

# various version info
%define sphinx_version 0.9.9
%define pbxt_version 1.0.11
%define revision_version 0.1

Summary:	MySQL: a very fast and reliable SQL database engine
Name: 		mysql
Version:	5.1.55
%define subrel 1
Release:	%mkrel 0
Group:		Databases
License:	GPL
URL:		http://www.mysql.com
Source0:	http://mysql.dataphone.se/Downloads/MySQL-5.1/mysql-%{version}.tar.gz
Source1:	http://mysql.dataphone.se/Downloads/MySQL-5.1/mysql-%{version}.tar.gz.asc
Source2:	http://downloads.mysql.com/docs/refman-5.1-en.html-chapter.tar.gz
Source3:	mysqld.sysconfig
Source4:	mysqld-ndbd.init
Source5:	mysqld-ndb.sysconfig
Source6:	mysqld-ndb_cpcd.init
Source7:	mysqld-ndb_cpcd.sysconfig
Source8:	mysqld-ndb_mgmd.init
Source9:	mysqld-ndb_mgmd.sysconfig
Source10:	config.ini
Source11:	my.cnf
Patch0:		mysql-lib64.diff
Patch1:		mysql-5.0.15-noproc.diff
Patch2:		mysql-mysqldumpslow_no_basedir.diff
Patch3:		mysql-errno.patch
Patch4:		mysql-logrotate.diff
Patch5:		mysql-initscript.diff
Patch6:		mysql-instance-manager.diff
Patch7:		mysql-5.1.30-federated-workaround.patch
Patch8:		mysql-enable-plugins.patch
Patch9:		mysql_upgrade-exit-status.patch
Patch11:	mysql-5.1.31-shebang.patch
Patch13:	mysql-5.1.33-scripts-paths.patch
Patch14:	mysql-5.1.35-test-variables-big.patch
Patch15:	mysql-5.1.36-bmove512.patch
Patch16:	mysql-5.1.36-hotcopy.patch
Patch17:	mysql-5.1.42-myslq-test.patch
Patch18:	mysql-install_db-quiet.patch
# addons
Source99:	http://patg.net/downloads/convert_engine.pl
Source100:	http://www.sphinxsearch.com/downloads/sphinx-%{sphinx_version}.tar.gz
Patch100:	sphinx-plugindir_fix.diff
Patch101:	sphinx-0.9.8.1-no_-DENGINE_fix.diff
Source300:	http://www.primebase.org/download/pbxt-%{pbxt_version}-6-pre-ga.tar.gz
Patch300:	pbxt-1.0.06-beta-avoid-version_fix.diff
Source400:	http://www.ddengine.org/dl/revision/files/revisionv01.tar.gz
Patch400:	revision-0.1-build_fix.diff
Patch401:	mysql-5.1.53-revision-0.1_fix.diff
Patch1000:	mysql-5.1.30-use_-avoid-version_for_plugins.diff
Patch2000:	mysql-5.1.44-CVE-2008-7247.diff
Requires(post): rpm-helper
Requires(preun): rpm-helper
Requires(pre): rpm-helper
Requires(postun): rpm-helper
Requires(post): mysql-common = %{version}-%{release}
Requires(preun): mysql-common = %{version}-%{release}
Requires(post): mysql-client = %{version}-%{release}
Requires(preun): mysql-client = %{version}-%{release}
Requires(postun): mysql-common = %{version}-%{release}
Requires(postun): mysql-client = %{version}-%{release}
Requires:	mysql-common = %{version}-%{release}
Requires:	mysql-core = %{version}-%{release}
Requires:	mysql-client = %{version}-%{release}
BuildRequires:	autoconf2.5
BuildRequires:	automake1.7
BuildRequires:	bison
BuildRequires:	doxygen
BuildRequires:	glibc-devel
BuildRequires:	libstdc++-devel
BuildRequires:	libtermcap-devel
BuildRequires:	ncurses-devel
BuildRequires:	openssl-devel
BuildRequires:	python
BuildRequires:	readline-devel
BuildRequires:	tetex
BuildRequires:	texinfo
BuildRequires:	zlib-devel
BuildRequires:	dos2unix
BuildRequires:	multiarch-utils >= 1.0.3
BuildRequires:	xfs-devel
BuildConflicts:	edit-devel
Provides:	msqlormysql MySQL-server mysqlserver MySQL = %{version}-%{release}
Obsoletes:	MySQL MySQL-devel <= 3.23.39
Conflicts:	MySQL-Max > 4.0.11
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
and robust SQL (Structured Query Language) database server. MySQL Server
is intended for mission-critical, heavy-load production systems as well
as for embedding into mass-deployed software. MySQL is a trademark of
MySQL AB.

Please see the documentation and the manual for more information.

%package	max
Summary:	MySQL - server with extended functionality
Group:		Databases
Requires(post): rpm-helper
Requires(preun): rpm-helper
Requires(pre): rpm-helper
Requires(postun): rpm-helper
Requires(post): mysql-common = %{version}-%{release}
Requires(preun): mysql-common = %{version}-%{release}
Requires(post): mysql-client = %{version}-%{release}
Requires(preun): mysql-client = %{version}-%{release}
Requires(postun): mysql-common = %{version}-%{release}
Requires(postun): mysql-client = %{version}-%{release}
Requires:	mysql-common = %{version}-%{release}
Requires:	mysql-client = %{version}-%{release}
Provides:	msqlormysql MySQL-server mysqlserver mysql MySQL-Max = %{version}-%{release}
Obsoletes:	MySQL-Max
Obsoletes:	MySQL-NDB
Conflicts:	MySQL > 4.0.11

%description	max 
Optional MySQL server binary that supports features like transactional tables
and more. You can use it as an alternate to MySQL basic server. The mysql-max
server is compiled with the following storage engines:

 - Ndbcluster Storage Engine interface
 - Archive Storage Engine
 - CSV Storage Engine
 - Federated Storage Engine
 - User Defined Functions (UDFs).
 - Blackhole Storage Engine
 - Partition Storage Engine

Addon storage engines (use with care):
 - Sphinx storage engine %{sphinx_version}
 - PBXT Storage Engine %{pbxt_version}
 - Revision Storage Engine %{revision_version}

%package	ndb-storage
Summary:	MySQL - ndbcluster storage engine
Group:		System/Servers
Requires(post): rpm-helper
Requires(preun): rpm-helper
Provides:	MySQL-ndb-storage = %{version}-%{release}
Obsoletes:	MySQL-ndb-storage

%description	ndb-storage
This package contains the ndbcluster storage engine. It is necessary to have
this package installed on all computers that should store ndbcluster table
data. Note that this storage engine can only be used in conjunction with the
MySQL Max server.

%package	ndb-management
Summary:	MySQL - ndbcluster storage engine management
Group:		System/Servers
Requires(post): rpm-helper
Requires(preun): rpm-helper
Requires(post): mysql-common = %{version}-%{release}
Requires(preun): mysql-common = %{version}-%{release}
Requires(post): mysql-client = %{version}-%{release}
Requires(preun): mysql-client = %{version}-%{release}
Requires:	mysql-common = %{version}-%{release}
Requires:	mysql-client = %{version}-%{release}
Provides:	MySQL-ndb-management = %{version}-%{release}
Obsoletes:	MySQL-ndb-management

%description	ndb-management
This package contains ndbcluster storage engine management. It is necessary to
have this package installed on at least one computer in the cluster.

%package	ndb-tools
Summary:	MySQL - ndbcluster storage engine basic tools
Group:		System/Servers
Provides:	MySQL-ndb-tools = %{version}-%{release}
Obsoletes:	MySQL-ndb-tools

%description	ndb-tools
This package contains ndbcluster storage engine basic tools.

%package	ndb-extra
Summary:	MySQL - ndbcluster storage engine extra tools
Group:		System/Servers
Provides:	MySQL-ndb-extra = %{version}-%{release}
Obsoletes:	MySQL-ndb-extra

%description	ndb-extra
This package contains some extra ndbcluster storage engine tools for the
advanced user. They should be used with caution.

%package	core
Summary:	MySQL - server core binary
Group:		System/Servers
Conflicts:	MySQL < 5.1.39-3
Requires:	mysql-common-core = %{version}-%{release}

%description	core
Core mysqld server binary. For a full MySQL database server, install
package 'mysql'.

%package	common-core
Summary:	MySQL - common files required by core binary
Group:		System/Servers
Conflicts:	MySQL-common < 5.1.39-3

%description	common-core
Common files minimally required by mysqld server binary.

%package	common
Summary:	MySQL - common files
Group:		System/Servers
Requires(post): rpm-helper
Requires(preun): rpm-helper
Requires(pre): rpm-helper
Requires(postun): rpm-helper
Requires(post): mysql-client = %{version}-%{release}
Requires(preun): mysql-client = %{version}-%{release}
Requires(post): perl-DBD-mysql
Requires(preun): perl-DBD-mysql
Requires:	mysql-client = %{version}-%{release}
Requires:	perl-DBD-mysql
Requires:	mysql-common-core = %{version}-%{release}
Provides:	MySQL-common = %{version}-%{release}
Obsoletes:      MySQL-common

%description	common
Common files for the MySQL(TM) database server.

%package	client
Summary:	MySQL - Client
Group:		Databases
Requires(post): %{libname} = %{version}-%{release}
Requires(preun): %{libname} = %{version}-%{release}
Requires:	%{libname} = %{version}-%{release}
Provides:       MySQL-client = %{version}-%{release}
Obsoletes:      MySQL-client
# note to self: add a conflict here because files moved from -client (v4.0.x) to -common (v5.0.x) #19789
Conflicts:	MySQL-common < 5.0

%description	client
This package contains the standard MySQL clients.

%package	bench
Summary:	MySQL - Benchmarks and test system
Group:		System/Servers
Requires(post): mysql-client = %{version}-%{release}
Requires(preun): mysql-client = %{version}-%{release}
Requires:	mysql-client = %{version}-%{release}
Requires:	perl
Provides:       MySQL-bench = %{version}-%{release}
Obsoletes:      MySQL-bench

%description	bench
This package contains MySQL benchmark scripts and data.

%package -n	%{libname}
Summary:	MySQL - Shared libraries
Group:		System/Libraries
Obsoletes:	MySQL-shared-libs MySQL-shared
Provides:	MySQL-shared-libs = %{version}-%{release} mysql-shared-libs = %{version}-%{release}
Provides:	MySQL-shared = %{version}-%{release} mysql-shared = %{version}-%{release}

%description -n	%{libname}
This package contains the shared libraries (*.so*) which certain languages and
applications need to dynamically load and use MySQL.

%package -n	%{develname}
Summary:	MySQL - Development header files and libraries
Group:		Development/Other
Requires(post): %{libname} = %{version}-%{release}
Requires(preun): %{libname} = %{version}-%{release}
Requires(post): mysql-common = %{version}-%{release}
Requires(preun): mysql-common = %{version}-%{release}
Requires(post): mysql-client = %{version}-%{release}
Requires(preun): mysql-client = %{version}-%{release}
Requires:	%{libname} = %{version}-%{release}
Requires:	mysql-common = %{version}-%{release}
Requires:	mysql-client = %{version}-%{release}
Provides:	MySQL-devel = %{version}-%{release}
Provides:	mysql-devel = %{version}-%{release}
Obsoletes:	MySQL-devel
Obsoletes:	mysql-devel
Provides:	%{libname}-devel = %{version}-%{release}
Obsoletes:	%{libname}-devel
Conflicts:	%{mklibname mysql 12 -d}
Conflicts:	%{mklibname mysql 14 -d}
Conflicts:	%{mklibname mysql 15 -d}

%description -n	%{develname}
This package contains the development header files and libraries necessary to
develop MySQL client applications.

This package also contains the MySQL server as an embedded library.

The embedded MySQL server library makes it possible to run a full-featured
MySQL server inside the client application. The main benefits are increased
speed and more simple management for embedded applications.

The API is identical for the embedded MySQL version and the client/server
version.

%package -n	%{staticdevelname}
Summary:	MySQL - Static development libraries
Group:		Development/Other
Requires:	mysql-devel = %{version}-%{release}
Conflicts:	MySQL-devel < 5.0.16-5mdk
Provides:	MySQL-static-devel = %{version}-%{release}
Provides:	mysql-static-devel = %{version}-%{release}
Obsoletes:	mysql-static-devel
Provides:	%{libname}-static-devel = %{version}-%{release}
Obsoletes:	%{libname}-static-devel

%description -n	%{staticdevelname}
This package contains the static development libraries.

%package	doc
Summary:	Documentation for MySQL
Group:		Books/Other

%description	doc
This package contains the HTML documentation for MySQL.

%prep

%setup -q -n mysql-%{version} -a2

# put html docs in place
mv refman-5.1-en.html-chapter Docs/html

cp %{SOURCE99} convert_engine.pl

%patch0 -p1 -b .lib64
%patch1 -p0 -b .noproc
%patch2 -p0 -b .mysqldumpslow_no_basedir
%patch3 -p0 -b .errno_as_defines
%patch4 -p0 -b .logrotate
%patch5 -p0 -b .initscript
%patch6 -p0 -b .instance-manager
%patch7 -p0 -b .federated
%patch8 -p1 -b .enable-plugins
%patch9 -p0 -b .mysql_upgrade-exit-status
%patch11 -p1 -b .shebang
%patch13 -p0 -b .scripts-paths
%patch14 -p0 -b .test-variables-big
%patch15 -p0 -b .bmove512
%patch16 -p0 -b .hotcopy
%patch17 -p1 -b .myslq-test
%patch18 -p0 -b .install_db-quiet


# Sphinx storage engine
tar -zxf %{SOURCE100}
pushd sphinx-%{sphinx_version}
%patch100 -p0
%patch101 -p0
# use a more unique name for the sphinx search daemon
perl -pi -e "s|searchd|sphinx-searchd|g" mysqlse/*
popd
cp -rp sphinx-%{sphinx_version}/mysqlse storage/sphinx

# pbxt storage engine
tar -zxf %{SOURCE300}
pushd pbxt-%{pbxt_version}*
%patch300 -p0
popd

# revision storage engine
mkdir -p revision-%{revision_version}
tar -zxf %{SOURCE400} -C revision-%{revision_version}
pushd revision-%{revision_version}
%patch400 -p0
%patch401 -p0
cp -p src/* .
popd
cp -rp revision-%{revision_version} storage/revision

%patch1000 -p1 -b .use_-avoid-version_for_plugins

%patch2000 -p0 -b .CVE-2008-7247

# fix annoyances
perl -pi -e "s|AC_PROG_RANLIB|AC_PROG_LIBTOOL|g" configure*
perl -pi -e "s|^MAX_C_OPTIMIZE.*|MAX_C_OPTIMIZE=\"\"|g" configure*
perl -pi -e "s|^MAX_CXX_OPTIMIZE.*|MAX_CXX_OPTIMIZE=\"\"|g" configure*

mkdir -p Mandriva
cp %{SOURCE3} Mandriva/mysqld.sysconfig
cp %{SOURCE4} Mandriva/mysqld-ndbd.init
cp %{SOURCE5} Mandriva/mysqld-ndb.sysconfig
cp %{SOURCE6} Mandriva/mysqld-ndb_cpcd.init
cp %{SOURCE7} Mandriva/mysqld-ndb_cpcd.sysconfig
cp %{SOURCE8} Mandriva/mysqld-ndb_mgmd.init
cp %{SOURCE9} Mandriva/mysqld-ndb_mgmd.sysconfig
cp %{SOURCE10} Mandriva/config.ini
cp %{SOURCE11} Mandriva/my.cnf

# lib64 fix
perl -pi -e "s|/usr/lib/|%{_libdir}/|g" Mandriva/my.cnf

%build
# Run aclocal in order to get an updated libtool.m4 in generated
# configure script for "new" architectures (aka. x86_64, mips)
#autoreconf --install --force
#export WANT_AUTOCONF_2_5=1
libtoolize --automake --copy --force; aclocal -I config/ac-macros; autoheader; automake --foreign --add-missing --copy; autoconf

if [ -d BK ]; then
    pushd innobase
	libtoolize --automake --copy  --force; aclocal; autoheader; autoconf; automake
    popd
fi

%serverbuild
export CFLAGS="${CFLAGS:-%{optflags}}"
export CXXFLAGS="${CXXFLAGS:-%{optflags}}"
export FFLAGS="${FFLAGS:-%{optflags}}"

# (gb) We shall always have the fully versioned binary
# FIXME: Please, please, do tell why you need fully qualified version
GCC_VERSION=`gcc -dumpversion`
CFLAGS="$CFLAGS -fPIC"
%ifarch alpha x86_64
CXXFLAGS="$CXXFLAGS -fPIC"
%else
CXXFLAGS="$CXXFLAGS"
%endif

# MySQL 4.1.10 definitely doesn't work under strict aliasing; also,
# gcc 4.1 breaks MySQL 5.0.16 without -fwrapv
export CFLAGS="$CFLAGS -fno-strict-aliasing -fwrapv"
# extra C++ flags as per recommendations in mysql's INSTALL-SOURCE doc
export CXXFLAGS="$CFLAGS -felide-constructors -fno-rtti -fno-exceptions"

export MYSQL_BUILD_CC="gcc-$GCC_VERSION"
export MYSQL_BUILD_CXX="g++-$GCC_VERSION"

export MYSQL_BUILD_CFLAGS="$CFLAGS"
export MYSQL_BUILD_CXXFLAGS="$CXXFLAGS"

%if %{build_debug}
CFLAGS="$CFLAGS -DUNIV_MUST_NOT_INLINE -DEXTRA_DEBUG -DFORCE_INIT_OF_VARS -DSAFEMALLOC -DPEDANTIC_SAFEMALLOC -DSAFE_MUTEX"
%endif

#
# Use MYSQL_BUILD_PATH so that we can use a dedicated version of gcc
#
export PATH=${MYSQL_BUILD_PATH:-/bin:/usr/bin}
export PS='/bin/ps'
export FIND_PROC='/bin/ps p $$PID'
export KILL='/bin/kill'
export CHECK_PID='/bin/kill -0 $$PID'

################################################################################
# make the plain mysqld server
%configure2_5x  \
    --prefix=/ \
    --exec-prefix=%{_prefix} \
    --libexecdir=%{_sbindir} \
    --libdir=%{_libdir} \
    --sysconfdir=%{_sysconfdir} \
    --datadir=%{_datadir} \
    --localstatedir=/var/lib/mysql \
    --infodir=%{_infodir} \
    --includedir=%{_includedir} \
    --mandir=%{_mandir} \
    --with-pic \
    --with-extra-charsets=all \
    --enable-assembler \
    --enable-local-infile \
    --enable-largefile=yes \
    --without-readline \
    --without-libwrap \
    --with-ssl=%{_libdir} \
    --with-big-tables \
    --enable-thread-safe-client \
    --with-fast-mutexes \
%if %{build_debug}
    --with-debug=full \
%else
    --without-debug \
%endif
    --with-mysqld-user=%{muser} \
    --with-unix-socket-path=/var/lib/mysql/mysql.sock \
    --disable-shared \
    --enable-static \
    --with-comment='Mandriva Linux - MySQL Standard Edition (GPL)' \
    --without-embedded-server \
    --with-plugin-archive \
    --with-plugin-innobase \
    --without-plugin-daemon_example \
    --without-plugin-example \
    --without-plugin-ftexample \
    --without-plugin-blackhole \
    --without-plugin-federated \
    --without-plugin-innodb_plugin \
    --without-plugin-ndbcluster \
    --without-plugin-partition \
    --without-plugin-revision \
    --without-plugin-sphinx

# benchdir does not fit in above model. Maybe a separate bench distribution
%make benchdir_root=%{buildroot}%{_datadir}

# tuck away various built files
make DESTDIR=`pwd`/STD benchdir_root=%{_datadir} testdir=%{_datadir}/mysql-test install

################################################################################
# cleanup
make clean

################################################################################
# make the mysqld-max server
%configure2_5x \
    --prefix=/ \
    --exec-prefix=%{_prefix} \
    --libexecdir=%{_sbindir} \
    --libdir=%{_libdir} \
    --sysconfdir=%{_sysconfdir} \
    --datadir=%{_datadir} \
    --localstatedir=/var/lib/mysql \
    --infodir=%{_infodir} \
    --includedir=%{_includedir} \
    --mandir=%{_mandir} \
    --with-pic \
    --with-extra-charsets=all \
    --enable-assembler \
    --enable-local-infile \
    --enable-largefile=yes \
    --without-readline \
    --without-libwrap \
    --with-ssl=%{_libdir} \
    --with-big-tables \
    --enable-thread-safe-client \
    --with-fast-mutexes \
%if %{build_debug}
    --with-debug=full \
%else
    --without-debug \
%endif
    --with-mysqld-user=%{muser} \
    --with-unix-socket-path=/var/lib/mysql/mysql.sock \
    --enable-shared \
    --enable-static \
    --with-comment='Mandriva Linux - MySQL Max Edition (GPL)' \
    --with-embedded-server \
    --with-big-tables \
    --with-plugins=ndbcluster \
    --with-plugin-partition \
    --with-ndbcluster \
    --with-ndb-shm \
    --with-server-suffix="-Max"

%make benchdir_root=%{buildroot}%{_datadir}

# this one is built dynamically..., heh... 
pushd pbxt-%{pbxt_version}*
autoreconf -fis
%configure2_5x \
    --enable-shared \
    --enable-static \
    --with-mysql=../ \
    --with-plugindir=%{_libdir}/mysql/plugin
%make
popd

################################################################################
# run the tests
%if %{build_test}
# disable failing tests
#echo "mysql_client_test : Unstable test case, bug#12258" >> mysql-test/t/disabled.def
#echo "openssl_1 : Unstable test case" >> mysql-test/t/disabled.def
#echo "rpl_openssl : Unstable test case" >> mysql-test/t/disabled.def
echo "rpl_trigger : Unstable test case" >> mysql-test/t/disabled.def
echo "type_enum : Unstable test case" >> mysql-test/t/disabled.def
echo "windows : For MS Windows only" >> mysql-test/t/disabled.def
echo "ndb_restore_different_endian_data : does not pass" >> mysql-test/t/disabled.def
# set some test env, should be free high random ports...
#export MYSQL_TEST_MANAGER_PORT=9305
#export MYSQL_TEST_MASTER_PORT=9306
#export MYSQL_TEST_SLAVE_PORT=9308
#export MYSQL_TEST_NDB_PORT=9350
make check
#make test
#%ifnarch s390x
#pushd mysql-test
#    ./mysql-test-run.pl \
#    --force \
#    --timer \
#    --master_port=$MYSQL_TEST_MASTER_PORT \
#    --slave_port=$MYSQL_TEST_SLAVE_PORT \
#    --ndbcluster_port=$MYSQL_TEST_NDB_PORT \
#    --testcase-timeout=60 \
#    --suite-timeout=120 || false
#popd
#%endif

pushd mysql-test
export LANG=C
export LC_ALL=C
export LANGUAGE=C
    perl ./mysql-test-run.pl \
    --timer \
    --testcase-timeout=60 \
    --suite-timeout=120 || false
popd

%endif

%install 
rm -rf %{buildroot}

# don't fiddle with the initscript!
export DONT_GPRINTIFY=1

%if %{build_debug}
export DONT_STRIP=1
%endif

install -d %{buildroot}%{_sysconfdir}/sysconfig
install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_var}/run/{mysqld,ndb_cpcd}
install -d %{buildroot}%{_var}/log/mysqld
install -d %{buildroot}/var/lib/mysql/{mysql,test}
install -d %{buildroot}/var/lib/mysql-cluster

%makeinstall_std benchdir_root=%{_datadir} testdir=%{_datadir}/mysql-test

pushd pbxt-%{pbxt_version}*
%makeinstall_std
popd

# antibork...
mv %{buildroot}%{_libdir}/mysql/ha_* %{buildroot}%{_libdir}/mysql/plugin/

# nuke one useless plugin
rm -f %{buildroot}%{_libdir}/mysql/plugin/ha_example*

mv %{buildroot}%{_sbindir}/mysqld %{buildroot}%{_sbindir}/mysqld-max
install -m0755 STD/usr/sbin/mysqld %{buildroot}%{_sbindir}/mysqld

# install init scripts
install -m0755 support-files/mysql.server %{buildroot}%{_initrddir}/mysqld
install -m0755 support-files/mysql.server %{buildroot}%{_initrddir}/mysqld-max
install -m0755 Mandriva/mysqld-ndbd.init %{buildroot}%{_initrddir}/mysqld-ndbd
install -m0755 Mandriva/mysqld-ndb_cpcd.init %{buildroot}%{_initrddir}/mysqld-ndb_cpcd
install -m0755 Mandriva/mysqld-ndb_mgmd.init %{buildroot}%{_initrddir}/mysqld-ndb_mgmd

# fix status and subsys
perl -pi -e 's/status mysqld\b/status mysqld-max/g;s,(/var/lock/subsys/mysqld\b),${1}-max,' %{buildroot}%{_initrddir}/mysqld-max

# mysqld-max needs special treatment running under the instance manager...
perl -pi -e "s|--default-mysqld-path=%{_sbindir}/mysqld|--default-mysqld-path=%{_sbindir}/mysqld-max|g" %{buildroot}%{_initrddir}/mysqld-max
perl -pi -e "s|--mysqld=mysqld|--mysqld=mysqld-max|g" %{buildroot}%{_initrddir}/mysqld-max
perl -pi -e "s|libexecdir/mysqld|libexecdir/mysqld-max|g" %{buildroot}%{_initrddir}/mysqld-max

# install configuration files
install -m0644 Mandriva/mysqld.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/mysqld
install -m0644 Mandriva/mysqld-ndb.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/mysqld-ndbd
install -m0644 Mandriva/mysqld-ndb_cpcd.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/mysqld-ndb_cpcd
install -m0644 Mandriva/mysqld-ndb_mgmd.sysconfig %{buildroot}%{_sysconfdir}/sysconfig/mysqld-ndb_mgmd
install -m0644 Mandriva/my.cnf %{buildroot}%{_sysconfdir}/my.cnf
install -m0644 Mandriva/config.ini %{buildroot}/var/lib/mysql-cluster/config.ini

# Install docs
install -m0644 Docs/mysql.info %{buildroot}%{_infodir}/mysql.info

# Fix libraries
mv %{buildroot}%{_libdir}/mysql/libmysqlclient.* %{buildroot}%{_libdir}/
mv %{buildroot}%{_libdir}/mysql/libmysqlclient_r.* %{buildroot}%{_libdir}/
mv %{buildroot}%{_libdir}/mysql/libndbclient.* %{buildroot}%{_libdir}/
perl -pi -e "s|%{_libdir}/mysql|%{_libdir}|" %{buildroot}%{_libdir}/*.la

pushd %{buildroot}%{_bindir}
    ln -sf mysqlcheck mysqlrepair
    ln -sf mysqlcheck mysqlanalyze
    ln -sf mysqlcheck mysqloptimize
popd

# touch some files
touch %{buildroot}%{_sysconfdir}/mysqlmanager.passwd
echo "#" > %{buildroot}%{_sysconfdir}/ndb_cpcd.conf
echo "#" > %{buildroot}/var/lib/mysql/Ndb.cfg

install -m0755 convert_engine.pl %{buildroot}%{_bindir}/mysql_convert_engine

pushd pbxt-%{pbxt_version}*
    for i in ChangeLog TODO AUTHORS COPYING NEWS README; do
	cp $i ../${i}.pbxt
    done
popd

pushd revision-%{revision_version}
    for i in AUTHORS ChangeLog COPYING INSTALL README TODO; do
	cp $i ../${i}.revision
    done
popd

# nuke -Wl,--as-needed from the mysql_config file
perl -pi -e "s|^ldflags=.*|ldflags=\'-rdynamic\'|g" %{buildroot}%{_bindir}/mysql_config

# house cleaning
rm -f %{buildroot}%{_datadir}/info/dir
rm -f %{buildroot}%{_bindir}/make_win_src_distribution
rm -f %{buildroot}%{_bindir}/make_win_binary_distribution
rm -f %{buildroot}%{_datadir}/mysql/*.spec
rm -f %{buildroot}%{_datadir}/mysql/postinstall
rm -f %{buildroot}%{_datadir}/mysql/preinstall
rm -f %{buildroot}%{_datadir}/mysql/mysql-log-rotate
rm -f %{buildroot}%{_datadir}/mysql/mysql.server
rm -f %{buildroot}%{_datadir}/mysql/mysqld_multi.server
rm -f %{buildroot}%{_bindir}/client_test
#rm -f %{buildroot}%{_bindir}/mysql_client_test*
rm -f %{buildroot}%{_bindir}/mysqltest_embedded
rm -f %{buildroot}%{_datadir}/mysql/binary-configure
rm -f %{buildroot}%{_mandir}/man1/make_win_bin_dist.1*
rm -f %{buildroot}%{_mandir}/man1/make_win_src_distribution.1*
rm -f %{buildroot}%{_datadir}/mysql/ChangeLog
rm -f %{buildroot}/mysql-test/lib/My/SafeProcess/my_safe_process

%multiarch_binaries %{buildroot}%{_bindir}/mysql_config
%multiarch_includes %{buildroot}%{_includedir}/mysql/my_config.h

cat > README.urpmi <<EOF

The initscript used to start mysql has been reverted to use the one shipped
by MySQL AB. This means the following changes:

 * The MYSQLD_OPTIONS="--skip-networking" option in the /etc/sysconfig/mysqld
   file has been removed, this is now set in the /etc/my.cnf file.

 * The MySQL Instance Manager is used by default, set use_mysqld_safe="1" in
   the /etc/sysconfig/mysqld file to use the old mysqld_safe script.

 * The generation of the initial system mysql database is now done when mysql
   is started from the initscript and only if the /var/lib/mysql/mysql
   directory is empty (mysql_install_db). Previousely this was quite hidden and
   silently done at (rpm) install time. As a consequence to this change you may
   have to perform some manual tasks to upgrade the mysql system database and
   such. So, doing something like this might help you:

   /etc/rc.d/init.d/mysqld stop
   TMPDIR=/var/tmp mysql_install_db
   mysql_upgrade

The extra MySQL-NDB server package has been merged into the MySQL-Max package 
and ndb related pieces has been split into different sub packages as done by
MySQL AB. The MySQL libraries and the MySQL-common sub package uses the
MySQL-Max build so that no functionality required by for example the NDB
parts are lost.

The MySQL-common package now ships with a default /etc/my.cnf file that is 
based on the my-medium.cnf file that comes with the source code.

To connect to the Instance Manager you need to pass the correct command line 
options like in the following examples:

  * mysql -u root --password=my_password --port=2273 --protocol=TCP
  * mysql -u root --password=my_password --socket=/var/lib/mysql/mysqlmanager.sock

Please note you also need to add a user in the /etc/mysqlmanager.passwd file and 
make sure the file is owned by the user under which the Instance Manager service 
is running under.

Starting from mysql-max-5.1.38-1 the storage engines is built as dynamically
loadable modules for the mysql-max version. You can either load the engines using
the  /etc/my.cnf file or at runtime. Please look at these lines in the /etc/my.cnf
file to enable additional engines or disable one or more of the default ones:

plugin_dir=%{_libdir}/mysql/plugin
plugin-load=ha_archive.so;ha_blackhole.so;ha_federated.so;ha_innodb.so

EOF

%pre
# disable plugins
perl -pi -e "s|^plugin-load|#plugin-load|g" %{_sysconfdir}/my.cnf
perl -pi -e "s|^federated|#federated|g" %{_sysconfdir}/my.cnf

%pre common
# delete the mysql group if no mysql user is found, before adding the user
if [ -z "`getent passwd %{muser}`" ] && ! [ -z "`getent group %{muser}`" ]; then
    %{_sbindir}/groupdel %{muser} > /dev/null 2>/dev/null || :
fi

%_pre_useradd %{muser} /var/lib/mysql /bin/bash

%post common
%_install_info mysql.info
%create_ghostfile %{_sysconfdir}/mysqlmanager.passwd %{muser} %{muser} 0640

%preun common
%_remove_install_info mysql.info

%post
# Change permissions so that the user that will run the MySQL daemon
# owns all needed files.
chown -R %{muser}:%{muser} /var/lib/mysql /var/run/mysqld /var/log/mysqld

# make sure the /var/lib/mysql directory can be accessed
chmod 711 /var/lib/mysql

%_post_service mysqld

%preun
if [ -x %{_sbindir}/mysqld-max -o -x %{_initrddir}/mysqld-max ]; then
    chkconfig --del mysqld-max > /dev/null 2>/dev/null || :
else
    %_preun_service mysqld
fi

%postun
if [ "$1" = "0" ]; then
    if [ -f /var/lock/subsys/mysqld -o -f /var/lock/subsys/mysqlmanager ]; then
        %{_initrddir}/mysqld restart > /dev/null 2>/dev/null || :
    fi
fi

%pre max
# enable plugins
perl -pi -e "s|^#plugin-load|plugin-load|g" %{_sysconfdir}/my.cnf
perl -pi -e "s|^#federated|federated|g" %{_sysconfdir}/my.cnf

%post max
# Change permissions so that the user that will run the MySQL daemon
# owns all needed files.
chown -R %{muser}:%{muser} /var/lib/mysql /var/run/mysqld /var/log/mysqld

# make sure the /var/lib/mysql directory can be accessed
chmod 711 /var/lib/mysql

%_post_service mysqld-max

%preun max
if [ -x %{_sbindir}/mysqld -o -x %{_initrddir}/mysqld ]; then
    chkconfig --del mysqld > /dev/null 2>/dev/null || :
else
    %_preun_service mysqld-max
fi

%postun max
if [ "$1" = "0" ]; then
    if [ -f /var/lock/subsys/mysqld-max -o -f /var/lock/subsys/mysqlmanager ]; then
        %{_initrddir}/mysqld-max restart > /dev/null 2>/dev/null || :
    fi
fi

%post ndb-storage
%_post_service mysqld-ndbd

%preun ndb-storage
%_preun_service mysqld-ndbd

%postun ndb-storage
if [ "$1" = "0" ]; then
    if [ -f /var/lock/subsys/mysqld-ndbd ]; then
        %{_initrddir}/mysqld-ndbd restart > /dev/null 2>/dev/null || :
    fi
fi

%post ndb-management
%create_ghostfile %{_sysconfdir}/ndb_cpcd.conf root root 0644
%create_ghostfile /var/lib/mysql/Ndb.cfg root root 0644
%_post_service mysqld-ndb_cpcd
%_post_service mysqld-ndb_mgmd

%preun ndb-management
%_preun_service mysqld-ndb_cpcd
%_preun_service mysqld-ndb_mgmd

%postun ndb-management
if [ "$1" = "0" ]; then
    if [ -f /var/lock/subsys/mysqld-ndb_cpcd ]; then
        %{_initrddir}/mysqld-ndb_cpcd restart > /dev/null 2>/dev/null || :
    fi
    if [ -f /var/lock/subsys/mysqld-ndb_mgmd ]; then
        %{_initrddir}/mysqld-ndb_mgmd restart > /dev/null 2>/dev/null || :
    fi
fi

%triggerin -n %{name} -- MySQL < 4.1.10
if [ -f /var/lock/subsys/mysql ]; then
    pidname="/var/lib/mysql/`/bin/hostname`.pid"
    if [ -f ${pidname} ]; then
	kill `cat ${pidname}`
	%{_initrddir}/mysqld start
    fi
fi

%triggerin -n %{name}-max -- MySQL-Max < 4.1.10
if [ -f /var/lock/subsys/mysql-max ]; then
    pidname="/var/lib/mysql/`/bin/hostname`.pid"
    if [ -f ${pidname} ]; then
	kill `cat ${pidname}`
	%{_initrddir}/mysqld-max start
    fi
fi

%if %mdkversion < 200900
%post -n %{libname} -p /sbin/ldconfig
%endif

%if %mdkversion < 200900
%postun -n %{libname} -p /sbin/ldconfig
%endif

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc README.urpmi
%attr(0755,root,root) %{_initrddir}/mysqld
%dir %{_libdir}/mysql/plugin

%files max
%defattr(-,root,root)
%doc README.urpmi
%doc *.pbxt *.revision
%attr(0755,root,root) %{_initrddir}/mysqld-max
%attr(0755,root,root) %{_sbindir}/mysqld-max
%dir %{_libdir}/mysql/plugin
%attr(0755,root,root) %{_libdir}/mysql/plugin/ha_archive.so
%attr(0755,root,root) %{_libdir}/mysql/plugin/ha_blackhole.so
%attr(0755,root,root) %{_libdir}/mysql/plugin/ha_federated.so
%attr(0755,root,root) %{_libdir}/mysql/plugin/ha_innodb.so
%attr(0755,root,root) %{_libdir}/mysql/plugin/ha_innodb_plugin.so
%attr(0755,root,root) %{_libdir}/mysql/plugin/ha_revision.so
%attr(0755,root,root) %{_libdir}/mysql/plugin/ha_sphinx.so
%attr(0755,root,root) %{_libdir}/mysql/plugin/libpbxt.so
%attr(0755,root,root) %{_libdir}/mysql/plugin/sphinx.so
%attr(0755,root,root) %{_bindir}/xtstat

%files ndb-storage
%defattr(-,root,root)
%attr(0755,root,root) %{_initrddir}/mysqld-ndbd
%attr(0644,root,root) %config(noreplace,missingok) %{_sysconfdir}/sysconfig/mysqld-ndbd
%attr(0755,root,root) %{_sbindir}/ndbd
%attr(0644,root,root) %{_mandir}/man8/ndbd.8*
%attr(0644,root,root) %{_mandir}/man8/ndbmtd.8*

%files ndb-management
%defattr(-,root,root)
%ghost %attr(0644,root,root) %config(noreplace,missingok) %{_sysconfdir}/ndb_cpcd.conf
%ghost %attr(0644,root,root) %config(noreplace,missingok) /var/lib/mysql/Ndb.cfg
%attr(0644,root,root) %config(noreplace,missingok) /var/lib/mysql-cluster/config.ini
%attr(0644,root,root) %config(noreplace,missingok) %{_sysconfdir}/sysconfig/mysqld-ndb_cpcd
%attr(0644,root,root) %config(noreplace,missingok) %{_sysconfdir}/sysconfig/mysqld-ndb_mgmd
%attr(0755,root,root) %{_initrddir}/mysqld-ndb_cpcd
%attr(0755,root,root) %{_initrddir}/mysqld-ndb_mgmd
%attr(0755,root,root) %{_sbindir}/ndb_mgmd
%attr(0755,root,root) %{_sbindir}/ndb_cpcd
%attr(0755,root,root) %{_bindir}/ndb_mgm
%attr(0755,%{muser},%{muser}) %dir %{_var}/run/ndb_cpcd
%attr(0644,root,root) %{_mandir}/man1/ndb_cpcd.1*
%attr(0644,root,root) %{_mandir}/man8/ndb_mgmd.8*

%files ndb-tools
%defattr(-,root,root)
%attr(0755,root,root) %{_bindir}/ndb_print_schema_file
%attr(0755,root,root) %{_bindir}/ndb_print_sys_file
%attr(0755,root,root) %{_bindir}/ndb_config
%attr(0755,root,root) %{_bindir}/ndb_desc
%attr(0755,root,root) %{_bindir}/ndb_error_reporter
%attr(0755,root,root) %{_bindir}/ndb_mgm
%attr(0755,root,root) %{_bindir}/ndb_print_backup_file
%attr(0755,root,root) %{_bindir}/ndb_restore
%attr(0755,root,root) %{_bindir}/ndb_select_all
%attr(0755,root,root) %{_bindir}/ndb_select_count
%attr(0755,root,root) %{_bindir}/ndb_show_tables
%attr(0755,root,root) %{_bindir}/ndb_size.pl
%attr(0755,root,root) %{_bindir}/ndb_test_platform
%attr(0755,root,root) %{_bindir}/ndb_waiter
%attr(0644,root,root) %{_mandir}/man1/ndb_config.1*
%attr(0644,root,root) %{_mandir}/man1/ndb_desc.1*
%attr(0644,root,root) %{_mandir}/man1/ndbd_redo_log_reader.1*
%attr(0644,root,root) %{_mandir}/man1/ndb_error_reporter.1*
%attr(0644,root,root) %{_mandir}/man1/ndb_mgm.1*
%attr(0644,root,root) %{_mandir}/man1/ndb_print_backup_file.1*
%attr(0644,root,root) %{_mandir}/man1/ndb_print_schema_file.1*
%attr(0644,root,root) %{_mandir}/man1/ndb_print_sys_file.1*
%attr(0644,root,root) %{_mandir}/man1/ndb_restore.1*
%attr(0644,root,root) %{_mandir}/man1/ndb_select_all.1*
%attr(0644,root,root) %{_mandir}/man1/ndb_select_count.1*
%attr(0644,root,root) %{_mandir}/man1/ndb_show_tables.1*
%attr(0644,root,root) %{_mandir}/man1/ndb_size.pl.1*
%attr(0644,root,root) %{_mandir}/man1/ndb_waiter.1*

%files ndb-extra
%defattr(-,root,root)
%attr(0755,root,root) %{_bindir}/ndb_drop_index
%attr(0755,root,root) %{_bindir}/ndb_drop_table
%attr(0755,root,root) %{_bindir}/ndb_delete_all
%attr(0644,root,root) %{_mandir}/man1/ndb_delete_all.1*
%attr(0644,root,root) %{_mandir}/man1/ndb_drop_index.1*
%attr(0644,root,root) %{_mandir}/man1/ndb_drop_table.1*

%files client
%defattr(-,root,root)
%attr(0755,root,root) %{_bindir}/msql2mysql
%attr(0755,root,root) %{_bindir}/mysql
%attr(0755,root,root) %{_bindir}/mysqlaccess
%attr(0755,root,root) %{_bindir}/mysqladmin
%attr(0755,root,root) %{_bindir}/mysqlanalyze
%attr(0755,root,root) %{_bindir}/mysqlbinlog
%attr(0755,root,root) %{_bindir}/mysqlcheck
%attr(0755,root,root) %{_bindir}/mysqldump
%attr(0755,root,root) %{_bindir}/mysqldumpslow
%attr(0755,root,root) %{_bindir}/mysql_find_rows
%attr(0755,root,root) %{_bindir}/mysqlimport
%attr(0755,root,root) %{_bindir}/mysqloptimize
%attr(0755,root,root) %{_bindir}/mysqlrepair
%attr(0755,root,root) %{_bindir}/mysqlshow
%attr(0755,root,root) %{_bindir}/mysqlslap
%attr(0755,root,root) %{_bindir}/mysql_waitpid
%attr(0644,root,root) %{_mandir}/man1/msql2mysql.1*
%attr(0644,root,root) %{_mandir}/man1/myisam_ftdump.1*
%attr(0644,root,root) %{_mandir}/man1/mysql.1*
%attr(0644,root,root) %{_mandir}/man1/mysqlaccess.1*
%attr(0644,root,root) %{_mandir}/man1/mysqladmin.1*
%attr(0644,root,root) %{_mandir}/man1/mysqlbinlog.1*
%attr(0644,root,root) %{_mandir}/man1/mysqlcheck.1*
%attr(0644,root,root) %{_mandir}/man1/mysqldump.1*
%attr(0644,root,root) %{_mandir}/man1/mysqldumpslow.1*
%attr(0644,root,root) %{_mandir}/man1/mysql_find_rows.1*
%attr(0644,root,root) %{_mandir}/man1/mysqlimport.1*
%attr(0644,root,root) %{_mandir}/man1/mysqlshow.1*
%attr(0644,root,root) %{_mandir}/man1/mysql_waitpid.1*

%files bench
%defattr(-,root,root)
%doc sql-bench/README
%attr(0755,root,root) %{_bindir}/mysql_client_test
%attr(0755,root,root) %{_bindir}/mysql_client_test_embedded
%{_datadir}/sql-bench
%attr(-,mysql,mysql) %{_datadir}/mysql-test
%attr(0644,root,root) %{_mandir}/man1/mysql-stress-test.pl.1*
%attr(0644,root,root) %{_mandir}/man1/mysql-test-run.pl.1*
%attr(0644,root,root) %{_mandir}/man1/mysql_client_test.1*
%attr(0644,root,root) %{_mandir}/man1/mysql_client_test_embedded.1*
%attr(0644,root,root) %{_mandir}/man1/mysqltest.1*
%attr(0644,root,root) %{_mandir}/man1/mysqltest_embedded.1*

%files core
%defattr(-,root,root) 
%attr(0755,root,root) %{_sbindir}/mysqld

%files common-core
%defattr(-,root,root)
%dir %{_datadir}/mysql
%{_datadir}/mysql/english
%{_datadir}/mysql/charsets

%files common
%defattr(-,root,root) 
%doc README COPYING support-files/*.cnf
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/sysconfig/mysqld
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/my.cnf
%ghost %attr(0640,%{muser},%{muser}) %config(noreplace,missingok) %{_sysconfdir}/mysqlmanager.passwd
%attr(0755,root,root) %{_bindir}/innochecksum
%attr(0755,root,root) %{_bindir}/myisamchk
%attr(0755,root,root) %{_bindir}/myisam_ftdump
%attr(0755,root,root) %{_bindir}/myisamlog
%attr(0755,root,root) %{_bindir}/myisampack
%attr(0755,root,root) %{_bindir}/my_print_defaults
%attr(0755,root,root) %{_bindir}/mysqlbug
%attr(0755,root,root) %{_bindir}/mysql_convert_engine
%attr(0755,root,root) %{_bindir}/mysql_convert_table_format
%attr(0755,root,root) %{_bindir}/mysqld_multi
%attr(0755,root,root) %{_bindir}/mysqld_safe
%attr(0755,root,root) %{_bindir}/mysql_fix_extensions 
%attr(0755,root,root) %{_bindir}/mysql_fix_privilege_tables
%attr(0755,root,root) %{_bindir}/mysqlhotcopy
%attr(0755,root,root) %{_bindir}/mysql_install_db
%attr(0755,root,root) %{_bindir}/mysql_secure_installation 
%attr(0755,root,root) %{_bindir}/mysql_setpermission
%attr(0755,root,root) %{_bindir}/mysqltest
%attr(0755,root,root) %{_bindir}/mysql_tzinfo_to_sql
%attr(0755,root,root) %{_bindir}/mysql_upgrade
%attr(0755,root,root) %{_bindir}/mysql_zap
%attr(0755,root,root) %{_bindir}/perror
%attr(0755,root,root) %{_bindir}/replace
%attr(0755,root,root) %{_bindir}/resolveip
%attr(0755,root,root) %{_bindir}/resolve_stack_dump
%attr(0755,root,root) %{_sbindir}/mysqlmanager
%{_infodir}/mysql.info*
%attr(0711,%{muser},%{muser}) %dir /var/lib/mysql-cluster
%attr(0711,%{muser},%{muser}) %dir /var/lib/mysql
%attr(0711,%{muser},%{muser}) %dir /var/lib/mysql/mysql
%attr(0711,%{muser},%{muser}) %dir /var/lib/mysql/test
%attr(0755,%{muser},%{muser}) %dir %{_var}/run/mysqld
%attr(0755,%{muser},%{muser}) %dir %{_var}/log/mysqld
%{_datadir}/mysql/mi_test_all
%{_datadir}/mysql/mi_test_all.res
%{_datadir}/mysql/*.cnf
%{_datadir}/mysql/fill_help_tables.sql
%{_datadir}/mysql/mysql_fix_privilege_tables.sql
%{_datadir}/mysql/mysql_system_tables.sql
%{_datadir}/mysql/mysql_system_tables_data.sql
%{_datadir}/mysql/mysql_test_data_timezone.sql
%{_datadir}/mysql/*.ini
%{_datadir}/mysql/errmsg.txt
%{_datadir}/mysql/czech
%{_datadir}/mysql/danish
%{_datadir}/mysql/dutch
%{_datadir}/mysql/estonian
%{_datadir}/mysql/french
%{_datadir}/mysql/german
%{_datadir}/mysql/greek
%{_datadir}/mysql/hungarian
%{_datadir}/mysql/italian
%{_datadir}/mysql/japanese
%{_datadir}/mysql/korean
%{_datadir}/mysql/norwegian
%{_datadir}/mysql/norwegian-ny
%{_datadir}/mysql/polish
%{_datadir}/mysql/portuguese
%{_datadir}/mysql/romanian
%{_datadir}/mysql/russian
%{_datadir}/mysql/serbian
%{_datadir}/mysql/slovak
%{_datadir}/mysql/spanish
%{_datadir}/mysql/swedish
%{_datadir}/mysql/ukrainian
%attr(0644,root,root) %{_mandir}/man1/innochecksum.1*
%attr(0644,root,root) %{_mandir}/man1/myisamchk.1*
%attr(0644,root,root) %{_mandir}/man1/myisamlog.1*
%attr(0644,root,root) %{_mandir}/man1/myisampack.1*
%attr(0644,root,root) %{_mandir}/man1/my_print_defaults.1*
%attr(0644,root,root) %{_mandir}/man1/mysqlbug.1*
%attr(0644,root,root) %{_mandir}/man1/mysql_convert_table_format.1*
%attr(0644,root,root) %{_mandir}/man1/mysqld_multi.1*
%attr(0644,root,root) %{_mandir}/man1/mysqld_safe.1*
%attr(0644,root,root) %{_mandir}/man1/mysql_fix_extensions.1*
%attr(0644,root,root) %{_mandir}/man1/mysql_fix_privilege_tables.1*
%attr(0644,root,root) %{_mandir}/man1/mysqlhotcopy.1*
%attr(0644,root,root) %{_mandir}/man1/mysql_install_db.1*
%attr(0644,root,root) %{_mandir}/man1/mysqlman.1*
%attr(0644,root,root) %{_mandir}/man1/mysql_secure_installation.1*
%attr(0644,root,root) %{_mandir}/man1/mysql.server.1*
%attr(0644,root,root) %{_mandir}/man1/mysql_setpermission.1*
%attr(0644,root,root) %{_mandir}/man1/mysqlslap.1*
%attr(0644,root,root) %{_mandir}/man1/mysql_tzinfo_to_sql.1*
%attr(0644,root,root) %{_mandir}/man1/mysql_upgrade.1*
%attr(0644,root,root) %{_mandir}/man1/mysql_zap.1*
%attr(0644,root,root) %{_mandir}/man1/perror.1*
%attr(0644,root,root) %{_mandir}/man1/replace.1*
%attr(0644,root,root) %{_mandir}/man1/resolveip.1*
%attr(0644,root,root) %{_mandir}/man1/resolve_stack_dump.1*
%attr(0644,root,root) %{_mandir}/man8/mysqld.8*
%attr(0644,root,root) %{_mandir}/man8/mysqlmanager.8*

%files -n %{libname}
%defattr(-,root,root)
%doc ChangeLog
%attr(0755,root,root) %{_libdir}/*.so.*

%files -n %{develname}
%defattr(-,root,root)
%doc INSTALL-SOURCE
%multiarch %{multiarch_bindir}/mysql_config
%attr(0755,root,root) %{_bindir}/mysql_config
%attr(0644,root,root) %{_libdir}/*.la
%attr(0644,root,root) %{_libdir}/mysql/plugin/*.la
%attr(0755,root,root) %{_libdir}/*.so
%dir %{_includedir}/mysql
%dir %{_includedir}/mysql/storage/ndb
%dir %{_includedir}/mysql/storage/ndb/mgmapi
%dir %{_includedir}/mysql/storage/ndb/ndbapi
%attr(0644,root,root) %{_includedir}/mysql/*.h
%attr(0644,root,root) %{_includedir}/mysql/storage/ndb/*.h
%attr(0644,root,root) %{_includedir}/mysql/storage/ndb/mgmapi/*.h
%attr(0644,root,root) %{_includedir}/mysql/storage/ndb/ndbapi/*.h*
%multiarch %{multiarch_includedir}/mysql/my_config.h
%attr(0644,root,root) %{_mandir}/man1/comp_err.1*
%attr(0644,root,root) %{_mandir}/man1/mysql_config.1*
%attr(0644,root,root) %{_datadir}/aclocal/mysql.m4

%files -n %{staticdevelname}
%defattr(-,root,root)
%dir %{_libdir}/mysql
%attr(0644,root,root) %{_libdir}/mysql/libdbug.a
%attr(0644,root,root) %{_libdir}/mysql/libheap.a
%attr(0644,root,root) %{_libdir}/mysql/libmyisam.a
%attr(0644,root,root) %{_libdir}/mysql/libmyisammrg.a
%attr(0644,root,root) %{_libdir}/mysql/libmysqld.a
%attr(0644,root,root) %{_libdir}/mysql/libmystrings.a
%attr(0644,root,root) %{_libdir}/mysql/libmysys.a
%attr(0644,root,root) %{_libdir}/mysql/libvio.a
%attr(0644,root,root) %{_libdir}/*.a
%attr(0755,root,root) %{_libdir}/mysql/plugin/*.a

%files doc
%defattr(-,root,root)
%doc Docs/html/*


%changelog
* Thu Feb 10 2011 Oden Eriksson <oeriksson@mandriva.com> 5.1.55-0.1mdv2010.0
- 5.1.55
- added better mysql version logic in the initscript

* Sun Jan 16 2011 Oden Eriksson <oeriksson@mandriva.com> 5.1.54-0.1mdv2010.0
- backport changes from the last 5.1 package in cooker and from 2010.1 updates

* Mon Nov 08 2010 Oden Eriksson <oeriksson@mandriva.com> 5.1.42-0.7mdv2010.0
- P1014: security fix for CVE-2010-3833 (upstream)
- P1015: security fix for CVE-2010-3834 (upstream)
- P1016: security fix for CVE-2010-3835 (upstream)
- P1017: security fix for CVE-2010-3836 (upstream)
- P1018: security fix for CVE-2010-3837 (upstream)
- P1019: security fix for CVE-2010-3838 (upstream)
- P1020: security fix for CVE-2010-3839 (upstream)
- P1021: security fix for CVE-2010-3840 (upstream)

* Wed Aug 18 2010 Oden Eriksson <oeriksson@mandriva.com> 5.1.42-0.6mdv2010.0
- P1006: security fix for upstream bug52512 (fixed in 5.1.49)
- P1007: security fix for upstream bug52711 (fixed in 5.1.49)
- P1008: security fix for upstream bug54007 (fixed in 5.1.49)
- P1009: security fix for upstream bug54393 (fixed in 5.1.49)
- P1010: security fix for upstream bug54477 (fixed in 5.1.49)
- P1011: security fix for upstream bug54575 (fixed in 5.1.49)
- P1012: security fix for upstream bug54044 (fixed in 5.1.49)
- P1013: security fix for CVE-2010-2008 (fixed in 5.1.48)
- stop using mysqlmanager per default and go back using the mysqld_safe script

* Tue May 25 2010 Oden Eriksson <oeriksson@mandriva.com> 5.1.42-0.5mdv2010.0
- P1003: security fix for CVE-2010-1850
- P1004: security fix for CVE-2010-1848
- P1005: security fix for CVE-2010-1849

* Wed May 19 2010 Oden Eriksson <oeriksson@mandriva.com> 5.1.42-0.4mdv2010.0
- P1002: security fix for CVE-2010-1626

* Fri May 07 2010 Oden Eriksson <oeriksson@mandriva.com> 5.1.42-0.3mdv2010.0
- fix #58843 (MysqlD init script exits too quickly) by Nicolas Rueff
- P1001: fix upstream bug #51770: UNINSTALL PLUGIN requires no privileges (CVE-2010-1621)

* Fri Feb 19 2010 Oden Eriksson <oeriksson@mandriva.com> 5.1.42-0.2mdv2010.0
- P1000: security fix for CVE-2008-7247

* Sun Jan 17 2010 Oden Eriksson <oeriksson@mandriva.com> 5.1.42-0.1mdv2010.0
- 5.1.42 (fixes CVE-2009-4030)
- new html manual
- use symbolic-links=0 in /etc/my.cnf to mitigate CVE-2008-7247 (fedora)

* Wed Dec 23 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.41-0.1mdv2010.0
- 5.1.41 (fixes CVE-2009-4028, CVE-2009-4019)
- new html manual
- pbxt-1.0.09
- sphinx-0.9.9
- rediffed some patches
- P500: security fix for CVE-2009-4030

* Fri Dec 11 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.41-2mdv2010.1
+ Revision: 476477
- sphinx-0.9.9
- rediffed some patches

* Fri Nov 20 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.41-1mdv2010.1
+ Revision: 467715
- 5.1.41
- new html manual
- pbxt-1.0.09
- rediffed one patch

* Fri Oct 23 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.40-1mdv2010.0
+ Revision: 459012
- 5.1.40
- new html manual

* Tue Oct 06 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.39-5mdv2010.0
+ Revision: 454626
- fix #51787 (MySQL not listed as database by Software management)

* Wed Sep 30 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.39-4mdv2010.0
+ Revision: 451828
- attempt to fix #54166 (%%postun script accesses just removed files,
 leading to errors on removal of mysql package)

* Tue Sep 29 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.39-3mdv2010.0
+ Revision: 450923
- fix #53457 (akonadi requires full mysql, while it only needs the basic executable)
- increase max_allowed_packet to 32MB
- fix #54102 (MySQL don't work)

* Sat Sep 26 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.39-2mdv2010.0
+ Revision: 449483
- the federated storage engine has to be statically built in for
  now due to "undefined symbol: dynstr_append_mem" problems.
  http://bugs.mysql.com/bug.php?id=40942

* Mon Sep 21 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.39-1mdv2010.0
+ Revision: 446797
- 5.1.39
- new html manual (S2)

* Sat Sep 12 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.38-2mdv2010.0
+ Revision: 438552
- fix deps (xfs-devel)

* Tue Sep 08 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.38-1mdv2010.0
+ Revision: 433451
- 5.1.38
- new html manual
- drop the federatedx engine
- rediffed P12,P14
- enable loadable engines for the max version and note this
  change in the README.urpmi file (read this file!)
- don't build the ndb development docs anymore and re-enable
  parallel build again (borked doxigen stuff...)

* Thu Aug 20 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.37-2mdv2010.0
+ Revision: 418521
- bump release
- try parallel build again
- use some of the fedora optimizations to try and fix #52936 (Qt4 mysql prepared statement corruption)
- minor cleanup

* Mon Aug 03 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.37-1mdv2010.0
+ Revision: 408404
- 5.1.37

* Wed Jul 01 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.36-1mdv2010.0
+ Revision: 391313
- 5.1.36
- new html manual
- drop P1000, the CVE-2008-4456 fix is finally in there...

* Tue Jun 09 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.35-1mdv2010.0
+ Revision: 384346
- 5.1.35
- new html manual

* Wed Apr 22 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.34-2mdv2009.1
+ Revision: 368671
- P1000: security fix for CVE-2008-4456

* Mon Apr 20 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.34-1mdv2009.1
+ Revision: 368419
- 5.1.34
- new html manual

* Tue Apr 07 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.33-1mdv2009.1
+ Revision: 364828
- 5.1.33
- new manual (S2)
- comment one line in P400 to fix build

* Thu Mar 05 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.32-1mdv2009.1
+ Revision: 348751
- 5.1.32 (fixes CVE-2009-0819)

* Wed Feb 25 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.31-2mdv2009.1
+ Revision: 344698
- rebuilt against new readline

* Tue Feb 17 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.31-1mdv2009.1
+ Revision: 341464
- 5.1.31
- new html manual
- rediffed some patches
- pbxt-1.0.07-rc
- provide the my.cnf as S11 instead of making it from the spec file
- don't provide the /var/lib/mysql/.tmp anymore, use /var/tmp
- don't tag language files like %%{_datadir}/mysql/swedish as %%lang(sv)
  because it only works if the locales has been installed first

* Tue Feb 10 2009 Oden Eriksson <oeriksson@mandriva.com> 5.1.30-5mdv2009.1
+ Revision: 339216
- no need to workaround #38398 anymore

* Thu Dec 18 2008 Oden Eriksson <oeriksson@mandriva.com> 5.1.30-4mdv2009.1
+ Revision: 315515
- disable -Werror=format-security, too complex to fix...

* Fri Dec 12 2008 Oden Eriksson <oeriksson@mandriva.com> 5.1.30-3mdv2009.1
+ Revision: 313615
- rediff some patches to meet the nofuzz criteria

* Thu Dec 04 2008 Oden Eriksson <oeriksson@mandriva.com> 5.1.30-2mdv2009.1
+ Revision: 309983
- added a bunch of storage engines...
- mention a possible upgrade scenario in the README.urpmi file
- fix one "typo"

* Fri Nov 28 2008 Oden Eriksson <oeriksson@mandriva.com> 5.1.30-1mdv2009.1
+ Revision: 307471
- fix the mysqld-max init script
- 5.1.30
- rediff patches, drop redundant ones
- sphinx-0.9.8.1
- nuke -Wl,--as-needed from the mysql_config file

* Mon Sep 29 2008 Oden Eriksson <oeriksson@mandriva.com> 5.0.67-3mdv2009.0
+ Revision: 289293
- added P300 (fixes CVE-2008-2079 in myisam)

* Sat Sep 06 2008 Guillaume Rousse <guillomovitch@mandriva.org> 5.0.67-2mdv2009.0
+ Revision: 281837
- make initscript provides mysqld, not mysql (bug #40845)

* Sat Aug 09 2008 Oden Eriksson <oeriksson@mandriva.com> 5.0.67-1mdv2009.0
+ Revision: 270052
- 5.0.67
- drop P15,P16,P17,P18,P19,P20,P21,P22,P23,P24,P25,P26,P200,P201,P202,P203,
  P300,P301, it's fixed with this version
- rediffed P2,P12
- new S2

* Sat Jul 26 2008 Oden Eriksson <oeriksson@mandriva.com> 5.0.51b-5mdv2009.0
+ Revision: 250242
- sphinx-0.9.8 (final)

* Sat Jul 19 2008 Guillaume Rousse <guillomovitch@mandriva.org> 5.0.51b-4mdv2009.0
+ Revision: 238810
- fix init script dependency: don't wait for nscd to start

* Wed Jul 16 2008 Oden Eriksson <oeriksson@mandriva.com> 5.0.51b-3mdv2009.0
+ Revision: 236348
- P301: fixes CVE-2008-2079 (patch from opensuse)
- fix buildroot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - description is neither licence nor url field

* Fri Jun 13 2008 Oden Eriksson <oeriksson@mandriva.com> 5.0.51b-2mdv2009.0
+ Revision: 218851
- bump release
- use _disable_ld_no_undefined to try and fix the build
- hardcode %%{_localstatedir}
- fix error: Missing %%files for subpackage mysql-test

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers
    - adapt to %%_localstatedir now being /var instead of /var/lib (#22312)

* Wed May 07 2008 Oden Eriksson <oeriksson@mandriva.com> 5.0.51b-1mdv2009.0
+ Revision: 202771
- 5.0.51b
- new html manual

* Fri Apr 18 2008 Per Øyvind Karlsen <peroyvind@mandriva.org> 5.0.51a-8mdv2009.0
+ Revision: 195721
- pass -p0 to patch40 (fixes build with rpm 5.1)

  + Oden Eriksson <oeriksson@mandriva.com>
    - sphinx-0.9.8-rc2
    - revert the "conform to the 2008 specs (don't start the services per
      default)" changes and let this be handled some other way...
    - fix #36235, #34904 (remove stale pid files)
    - added P26 that fixes upstream bug 32202 (coling)

* Tue Apr 01 2008 Oden Eriksson <oeriksson@mandriva.com> 5.0.51a-7mdv2008.1
+ Revision: 191448
- bump release
- revert back the TMP env fix
- fix the logic in P12

* Tue Apr 01 2008 Oden Eriksson <oeriksson@mandriva.com> 5.0.51a-6mdv2008.1
+ Revision: 191376
- rebuilt due to packet loss

* Mon Mar 31 2008 Oden Eriksson <oeriksson@mandriva.com> 5.0.51a-5mdv2008.1
+ Revision: 191196
- another approach at fixing #39356 with P4 instead
- another approach at fixing #38398 by making the initial mysql
  database from the initscript instead and document that change
  in READE.urpmi

* Tue Mar 25 2008 Oden Eriksson <oeriksson@mandriva.com> 5.0.51a-4mdv2008.1
+ Revision: 189905
- fix #38398 (mysql seems to have default root password after 2008.1 rc1 install)
- fix #39356 (mysqldumpslow cannot determine basedir)
- sphinx-0.9.8-rc1

* Wed Feb 13 2008 Oden Eriksson <oeriksson@mandriva.com> 5.0.51a-3mdv2008.1
+ Revision: 167181
- added upstream fixes for:
 - P22 - bug33201
 - P23 - bug26489
 - P24 - bug27427
 - P25 - bug28908
- rebuild
- remove borked hunk in mysql-install_script_mysqld_safe.diff

* Thu Jan 31 2008 Oden Eriksson <oeriksson@mandriva.com> 5.0.51a-2mdv2008.1
+ Revision: 160895
- use the latest sphinx-0.9.8-svn-r1112 release
- drop P101, it's implemented upstream
- adjust P102

* Wed Jan 30 2008 Oden Eriksson <oeriksson@mandriva.com> 5.0.51a-1mdv2008.1
+ Revision: 160261
- 5.0.51a (fixes CVE-2008-0226, CVE-2008-0227, bug29908, bug29801)
- dropped upstream fixes for:
 - P14  - bug32458
 - P301 - CVE-2007-6303
 - P302 - CVE-2007-6304
- Added upstream fixes:
 - P16 - bug31669
 - P17 - bug37300
 - P18 - bug30069
 - P19 - bug5731
 - P20 - bug29419
 - P21 - bug29446
- make it use UTF-8 per default in /etc/my.cnf (Raphael Gertz)

* Wed Jan 23 2008 Oden Eriksson <oeriksson@mandriva.com> 5.0.51-3mdv2008.1
+ Revision: 157233
- added P102 to make it recognize sphinx at "make test"
- enable running the test suite
- disable the ndb_restore_different_endian_data test for now
- added P27 (fedora)
- added upstream fixes:
 - P14  - bug32458
 - P15  - bug31761
 - P200 - bug26817 (debian)
 - P201 - bug31799 (debian)
 - P202 - bug33292 (debian)
 - P203 - bug33623 (debian)
 - P204 - bug16574 (debian)
- renumbered the sec fix patches:
 - P300: security fix for CVE-2007-5925
 - P301: security fix for CVE-2007-6303
 - P302: security fix for CVE-2007-6304
- fix #32313 (under cron.daily reports failure rotating mysqld.log and mysqlmanager.log access denied)
- P27: security fix for CVE-2007-5925
- P28: security fix for CVE-2007-6303
- P29: security fix for CVE-2007-6304

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request
    - remove URLs from description

* Fri Dec 07 2007 Oden Eriksson <oeriksson@mandriva.com> 5.0.51-2mdv2008.1
+ Revision: 116182
- broke out the html documentation into the mysql-doc sub package

* Thu Dec 06 2007 Oden Eriksson <oeriksson@mandriva.com> 5.0.51-1mdv2008.1
+ Revision: 116012
- 5.0.51
- drop P14, #29451 is fixed for real

* Wed Oct 31 2007 Oden Eriksson <oeriksson@mandriva.com> 5.0.45-8mdv2008.1
+ Revision: 104220
- added the experimental sphinx storage backend (http://www.sphinxsearch.com/)

* Fri Sep 28 2007 Oden Eriksson <oeriksson@mandriva.com> 5.0.45-7mdv2008.0
+ Revision: 93555
- fix #29321 (MySQL Daemon started, "DrakeConf Services" say stopped)
- fix #31919 (problems in 5.0.45-1mdv2008.0)

* Wed Sep 19 2007 Guillaume Rousse <guillomovitch@mandriva.org> 5.0.45-6mdv2008.0
+ Revision: 90004
- rebuild

* Mon Jul 23 2007 Oden Eriksson <oeriksson@mandriva.com> 5.0.45-5mdv2008.0
+ Revision: 54645
- fix #30226, #32020

* Thu Jul 19 2007 Oden Eriksson <oeriksson@mandriva.com> 5.0.45-4mdv2008.0
+ Revision: 53549
- fix #29451, #30051

* Tue Jul 17 2007 Oden Eriksson <oeriksson@mandriva.com> 5.0.45-3mdv2008.0
+ Revision: 52949
- delete the mysql group if no mysql user is found, before adding the user

* Mon Jul 16 2007 Oden Eriksson <oeriksson@mandriva.com> 5.0.45-2mdv2008.0
+ Revision: 52562
- bump release
- fix deps
- fix #28930, #30505

* Thu Jul 12 2007 Oden Eriksson <oeriksson@mandriva.com> 5.0.45-1mdv2008.0
+ Revision: 51628
- 5.0.45
- renamed from MySQL to mysql and fix deps accordingly
- dropped the upstream implemented CVE-2007-2691 fix
- rediffed P2,P12
- conform to the latest specs, don't start it per default and devel naming
- rename it from MySQL to mysql (to preserve history)

* Sat Jul 07 2007 Oden Eriksson <oeriksson@mandriva.com> 5.0.41-3mdv2008.0
+ Revision: 49579
- P100: security fix for CVE-2007-2691

* Thu Jun 07 2007 Oden Eriksson <oeriksson@mandriva.com> 5.0.41-2mdv2008.0
+ Revision: 36816
- use distro conditional -fstack-protector

* Fri May 11 2007 Oden Eriksson <oeriksson@mandriva.com> 5.0.41-1mdv2008.0
+ Revision: 26228
- 5.0.41
- drop opsolete/upstream patches; P14,P20,P21,P27,P28
- rediffed patches; P1

* Tue May 08 2007 Oden Eriksson <oeriksson@mandriva.com> 5.0.37-3mdv2008.0
+ Revision: 25069
- rebuild

